#!/usr/bin/perl

# This code is so damn ugly...

use strict;
use Term::ReadLine;
use DBI;

my $term = new Term::ReadLine 'MySQL Qouta Daemon installer';

print 
"\t\tMySQL Qouta Daemon installer

This simple installer will lead you through installation and configuration
of the MySQL Qouta Daemon. It will copy the files into chosen destinations,
make any necessary changes to them, create the config file and create the
quota database. If you accept any default (in brackets) then enter a blank
line. Copying is made by simple cp, so you can specify both paths and file
names. Look out for the configuration files - PASSWORDS ARE KEPT IN PLAIN
TEXT. Make sure those files aren't readable by random users.\n\nBase daemon setup:\n";
my $daemon_path = $term->readline("Where the daemon executable should be placed? (/usr/local/bin/)\n") || '/usr/local/bin/';
my $conf_path = $term->readline("Where the configuration file should be placed? (/etc/mysqlquota.conf)\n") || '/etc/mysql_quota.conf';
my $host = $term->readline("Hostname of the MySQL server to control? (localhost)\n") || 'localhost';
my $passwd = $term->readline("MySQL root password for that host?\n");
my $database = $term->readline("Database for internal use? (quotadb)\n") || 'quotadb';
my $take_update = $term->readline("Should the UPDATE privillege be taken when limit exceeded? [1/0] (0)\n");

print "CGI frontend for setting up individual quotas:\n";
my $install_frontend = $term->readline("Install the CGI frontend? [1/0] (1)\n");
$install_frontend = 1 unless $install_frontend eq '0';

my ($front_path, $fr_conf_path, $fr_charset);
if($install_frontend)
{
	$front_path = $term->readline("Where should the CGI script be located? (/var/www/cgi-bin/)\n") || '/var/www/cgi-bin/';
	print "Basically using the same configuration file for both daemon and frontend 
	is reasonable. Yet if you want the frontend connect as a different user, you
	can do this by maintaining a separate config.\n";
	$fr_conf_path = $term->readline("Where should the frontend configuration file be placed? ($conf_path)\n") || $conf_path;
	$fr_charset = $term->readline("What charset should be used by the frontend? (ISO-8859-1)\n") || 'ISO-8859-1';
}

$daemon_path=~ s/\/?$/\/mysqlquotad/ if(-d $daemon_path);
$conf_path=~   s/\/?$/\/mysqlquota.conf/ if(-d $conf_path);
$front_path=~  s/\/?$/\/mysqlquota.cgi/ if(-d $front_path);
$fr_conf_path=~s/\/?$/\/mysqlquota.conf/ if(-d $fr_conf_path);


print "\nCollected data:
Daemon path:\t\t$daemon_path
Config path:\t\t$conf_path
Host:\t\t\t$host
Password:\t\t$passwd
Quota database:\t\t$database
Take UPDATE priv:\t$take_update
Install frontend:\t$install_frontend\n";

print "Frontend path:\t\t$front_path
Frontend config:\t$fr_conf_path
Frontend charset:\t$fr_charset\n\n"
if($install_frontend);

my $continue = $term->readline("Proceed with installation? [1/0] (1)\n");
$continue = 1 unless $continue eq '0';
die "So be it.\n" unless $continue;

my $dba = DBI->connect(
	'DBI:mysql:mysql:'.$host,
	'root',
	$passwd,
	{RaiseError => 1, AutoCommit => 1}
) or die("Could not connect to database.\n");

$dba -> do ("CREATE DATABASE IF NOT EXISTS $database");

my $dbh = DBI->connect(
	'DBI:mysql:'.$database.':'.$host,
	'root',
	$passwd,
	{RaiseError => 1, AutoCommit => 1}
) or die("Could not connect to database.\n");

$dbh -> do("CREATE TABLE IF NOT EXISTS `quota`(`db` CHAR(64) NOT NULL,`limit` BIGINT NOT NULL,".
	"`exceeded` INTEGER DEFAULT 0 NOT NULL,PRIMARY KEY (`db`), UNIQUE (`db`));");

sub escape
{
	my $s = shift;
	$s=~s/\//\\\//g;
	$s=~s/\'/\\\'/g;
	return $s;
}
	
# This can be done in pure perl, but why bother?
system("cp files/mysqlquotad $daemon_path; 
	sed -e \"s/#INSTALL_CONFPATH/elsif\\(-e \\'".&escape($conf_path)."\\'\\)\\n\\{\\n\t\\&readconf\\(\\'".&escape($conf_path)."\\'\\);\\n\\}\\n/\" -i $daemon_path;
	cp files/conf $conf_path;
	sed -e 's/^host.*/host\t".&escape($host)."/' -i $conf_path;
	sed -e 's/^pass.*/pass\t".&escape($passwd)."/' -i $conf_path;
	sed -e 's/^db.*/db\t".&escape($database)."/' -i $conf_path;
	sed -e 's/^take_update.*/take_update\t".&escape($take_update)."/' -i $conf_path;");

if($install_frontend)
{
	system("cp files/conf $fr_conf_path;
		sed -e 's/^host.*/host\t".&escape($host)."/' -i $fr_conf_path;
		sed -e 's/^pass.*/pass\t".&escape($passwd)."/' -i $fr_conf_path;
		sed -e 's/^db.*/db\t".&escape($database)."/' -i $fr_conf_path;
		sed -e 's/^take_update.*/take_update\t".&escape($take_update)."/' -i $fr_conf_path;") unless ($conf_path eq $fr_conf_path);
	system("cp files/mysqlquota.cgi $front_path;
		sed -e \"s/#INSTALL_CONFPATH/if\\(-e \\'".&escape($fr_conf_path)."\\'\\)\\n\\{\\n\t\\&readconf\\(\\'".&escape($fr_conf_path)."\\'\\);\\n\\}\\n/\" -i $front_path;");
}
